package org.nakedobjects.applib;

public abstract class AbstractService extends AbstractContainedObject {
    protected void disposeInstance(Object persistentObject) {
        getContainer().disposeInstance(persistentObject);
    }

    public String getId() {
        return getClass().getName();
    }

    protected String getClassName() {
        return getClass().getName();
    }

    protected boolean isPersistent(Object object) {
        return getContainer().isPersistent(object);
    }

    protected void makePersistent(Object transientObject) {
        getContainer().makePersistent(transientObject);
    }

    protected <T> T newTransientInstance(Class<T> ofClass) {
        return getContainer().newTransientInstance(ofClass);
    }

    /**
     * Delete this object from the persistent object store.
     */
    protected void disposeInstance() {
        getContainer().disposeInstance(this);
    }
    // }}
}

// Copyright (c) Naked Objects Group Ltd.
