package org.nakedobjects.applib.value;

public class Percentage extends Magnitude {
    private static final long serialVersionUID = 1L;
    private final float value;

    public Percentage(final float value) {
        this.value = value;
    }

    public Percentage add(final float value) {
        return new Percentage((float) (floatValue() + value));
    }

    public Percentage add(final Percentage value) {
        return add(value.floatValue());
    }
/*
    public void divide(final double value) {
        setValue((float) (floatValue() / value));
    }
*/
    /**
     * Returns this value as an double.
     */
    public double doubleValue() {
        return value;
    }

    public boolean equals(final Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof Percentage)) {
            return false;
        }
        Percentage object = (Percentage) obj;
        return object.value == value;
    }

    /**
     * Returns this value as an float.
     */
    public float floatValue() {
        return value;
    }

    /**
     * Returns this value as an int.
     */
    public int intValue() {
        return (int) value;
    }

    /**
     */
    public boolean isEqualTo(final Magnitude magnitude) {
        if (magnitude instanceof Percentage) {
            return ((Percentage) magnitude).value == value;
        } else {
            throw new IllegalArgumentException("Parameter must be of type WholeNumber");
        }
    }

    public boolean isLessThan(final Magnitude magnitude) {
        if (magnitude instanceof Percentage) {
            return value < ((Percentage) magnitude).value;
        } else {
            throw new IllegalArgumentException("Parameter must be of type WholeNumber");
        }
    }

    /**
     * Returns this value as an long.
     */
    public long longValue() {
        return (long) value;
    }

    public Percentage multiply(final float value) {
        return new Percentage((float) (floatValue() * value));
    }

    /**
     * Returns this value as an short.
     */
    public short shortValue() {
        return (short) value;
    }

    public Percentage subtract(final float value) {
        return add(-value);
    }

    public Percentage subtract(final Percentage value) {
        return add(-value.floatValue());
    }
}
// Copyright (c) Naked Objects Group Ltd.
